import 'dart:async';

import 'package:flutter/services.dart';

// enum CFUPI {
//    GPAY, 
//    PHONEPE, 
//    PAYTM
// }

class CashfreePGSDK {

  static List<String> _required = [
      "stage",
      "appId",
      "orderId",
      "orderAmount",
      "orderCurrency",
      "customerEmail",
      "customerPhone",
      "tokenData"
    ];

  // Function to initiate the web checkout flow.
  static Future<Map<dynamic, dynamic>> doPayment(Map<String, dynamic> inputs) {
    Future<Map<dynamic, dynamic>> response;
    for (String element in _required) {
      if (!inputs.containsKey(element) || inputs[element].toString().isEmpty) {
        return _failureResponse(element + " not provided");
      }
    }
    MethodChannel channel = const MethodChannel('cashfree_pg');
    if (channel != null) {
      response = channel.invokeMethod('doPayment', inputs);
    } else {
      response = _failureResponse('Invalid channel');
    }
    return response;
  }

  // Function to initiate UPI Intent
  static Future<Map<dynamic, dynamic>> doUPIPayment(Map<String, dynamic> inputs) {
    Future<Map<dynamic, dynamic>> response;
    for (String element in _required) {
      if (!inputs.containsKey(element) || inputs[element].toString().isEmpty) {
        return _failureResponse(element + " not provided");
      }
    }

    MethodChannel channel = const MethodChannel('cashfree_pg');
    if(channel != null) {
      response = channel.invokeMapMethod("doUPIPayment", inputs);
    } else {
      response = _failureResponse("Invalid Channel");
    }
    return response;
  }

  // creates a failure response
  static Future<Map<dynamic, dynamic>> _failureResponse(String s) {
    var completer = new Completer<Map<dynamic, dynamic>>();
    Map<dynamic, dynamic> failureResponse = new Map<dynamic, dynamic>();
    failureResponse['txMsg'] = s;
    failureResponse['txStatus'] = 'FAILED';
    completer.complete(failureResponse);
    return completer.future;
  }
}
